package ConverterLib;

public class ConverterFactory {
	public static Converter getInstance(ConverterType type) {
		switch (type) {
		case TEMPERATURE_CONVERTER:
			return new TemperatureConverter();
		case LENGTH_CONVERTER:
			return new LengthConverter();
		case WEIGHT_CONVERTER:
			return new WeightConverter();
		case VOLUME_CONVERTER:
			return new VolumeConverter();
		case ANGLE_CONVERTER:
			return new AngleConverter();
		default:
			System.out.println("Unknown converter");
			return null;
		}
	}
	
	public static Converter getInstance(ConverterType type, int mode, double fromValue) {
		switch (type) {
		case TEMPERATURE_CONVERTER:
			return new TemperatureConverter(mode, fromValue);
		case LENGTH_CONVERTER:
			return new LengthConverter(mode, fromValue);
		case WEIGHT_CONVERTER:
			return new WeightConverter(mode, fromValue);
		case VOLUME_CONVERTER:
			return new VolumeConverter(mode, fromValue);
		case ANGLE_CONVERTER:
			return new AngleConverter(mode, fromValue);
		default:
			System.out.println("Unknown converter");
			return null;
		}
	}

	public static Converter getInstance(ConverterType type, String fromUnit, String toUnit, double fromValue) {
		switch (type) {
		case TEMPERATURE_CONVERTER:
			return new TemperatureConverter(fromUnit, toUnit, fromValue);
		case LENGTH_CONVERTER:
			return new LengthConverter(fromUnit, toUnit, fromValue);
		case WEIGHT_CONVERTER:
			return new WeightConverter(fromUnit, toUnit, fromValue);
		case VOLUME_CONVERTER:
			return new VolumeConverter(fromUnit, toUnit, fromValue);
		case ANGLE_CONVERTER:
			return new AngleConverter(fromUnit, toUnit, fromValue);
		default:
			System.out.println("Unknown converter");
			return null;
		}
	}
}
