package ConverterLib;

public enum ConverterType {
	TEMPERATURE_CONVERTER(1),
	LENGTH_CONVERTER(2),
	WEIGHT_CONVERTER(3),
	VOLUME_CONVERTER(4),
	ANGLE_CONVERTER(5);
	
	private final int type;
	ConverterType(int type) {
		this.type = type;
	}
	
	public int getType() {
		return type;
	}

	public static ConverterType valueOf(int value) {
		switch (value) { // switch
		case 1:
			return TEMPERATURE_CONVERTER;
		case 2:
			return LENGTH_CONVERTER;
		case 3:
			return WEIGHT_CONVERTER;
		case 4:
			return VOLUME_CONVERTER;
		case 5:
			return ANGLE_CONVERTER;
		}
		return null;
	}
	
	public static ConverterType nameOf(String name) {
		switch (name) { // switch
        case "1":
        case "µȯ":
        case "TEMPERATURE_CONVERTER":
			return TEMPERATURE_CONVERTER;
        case "2":
        case "̺ȯ":
        case "LENGTH_CONVERTER":
			return LENGTH_CONVERTER;
        case "3":
        case "Ժȯ":
        case "WEIGHT_CONVERTER":
			return WEIGHT_CONVERTER;
        case "4":
        case "Ǻȯ":
        case "VOLUME_CONVERTER":
			return VOLUME_CONVERTER;
        case "5":
        case "ȯ":
        case "ANGLE_CONVERTER":
			return ANGLE_CONVERTER;
		}
		return null;
	}
	
	public static String[] names() {
		String[] names = new String[ConverterType.values().length];
		for (ConverterType t : ConverterType.values()) 
			names[t.ordinal()] = t.toString();
		return names;
	}
}
