package ConverterLib;

public class LengthConverter extends Converter {
	public static final int KILOMETER_TO_MILE = 1;
	public static final int MILE_TO_KILOMETER = 2;
	public static final int METER_TO_KILOMETER = 3;

	public LengthConverter() {
		type = ConverterType.LENGTH_CONVERTER;
		convert();
	}
	
	public LengthConverter(int mode, double value) {
		this.type = ConverterType.LENGTH_CONVERTER;
		if (mode == KILOMETER_TO_MILE) {
			this.fromUnit = "KILOMETER";
			this.toUnit = "MILE";
		} else if (mode == MILE_TO_KILOMETER) {
			this.fromUnit = "MILE";
			this.toUnit = "KILOMETER";
		} else if (mode == METER_TO_KILOMETER) {
			this.fromUnit = "METER";
			this.toUnit = "KILOMETER";
		}
		this.fromValue = value;
		this.toValue = convert(fromUnit, toUnit, fromValue);
	}

	public LengthConverter(String fromUnit, String toUnit, double fromValue) {
		this.type = ConverterType.LENGTH_CONVERTER;
		this.fromUnit = fromUnit;
		this.toUnit = toUnit;
		this.fromValue = fromValue;
		this.toValue = convert(fromUnit, toUnit, fromValue);
	}

	@Override
	public void convert() {
    	this.fromUnit =  UserInput.getConverterUnit("Please select FROM (KILOMETER, MILE, METER): ");
    	this.toUnit =  UserInput.getConverterUnit("Please select TO (KILOMETER, MILE, METER): ");
		System.out.printf("Please enter length (%s): ", fromUnit);
		this.fromValue = UserInput.getDouble();
		this.toValue = convert(fromUnit, toUnit, fromValue);
		System.out.printf("%s = %f => %s = %f\n", fromUnit, fromValue, toUnit, toValue);
	}

	@Override
	public double convert(String fromUnit, String toUnit, double fromValue) {
		if  (fromUnit.equalsIgnoreCase("KILOMETER")) {
			if (toUnit.equalsIgnoreCase("MILE")) {
				return fromKilometerToMile(fromValue);
			} else if (toUnit.equalsIgnoreCase("METER")) {
				return fromKilometerToMeter(fromValue);
			}
			return fromValue;
		} else if (fromUnit.equalsIgnoreCase("MILE")) {
			if (toUnit.equalsIgnoreCase("KILOMETER")) {
				return fromMileToKilometer(fromValue);
			} else if (toUnit.equalsIgnoreCase("METER")) {
				return fromMileToMeter(fromValue);
			}
			return fromValue;
		} else if (fromUnit.equalsIgnoreCase("METER")) {
			if (toUnit.equalsIgnoreCase("KILOMETER")) {
				return fromMeterToKilometer(fromValue);
			} else if (toUnit.equalsIgnoreCase("MILE")) {
				return fromMeterToMile(fromValue);
			}
			return fromValue;
		}
		return fromValue;
	}
	
	@Override
	public double convertFrom(double value) { // kilometer -> mile
		return fromKilometerToMile(value);
	}

	@Override
	public double convertTo(double value) { // mile -> kilometer
		return fromMileToKilometer(value);
	}

	static double fromKilometerToMile(double km) {
        return (km * 0.62137);
    }

    static double fromKilometerToMeter(double km) {
        return (km * 1000);
    }
    
    static double fromMileToKilometer(double mile) {
        return (mile / 0.62137);
    }
    
	static double fromMileToMeter(double mile) {
        return (mile * 0.0062137);
    }

	static double fromMeterToKilometer(double m) {
        return (m / 1000);
    }

    static double fromMeterToMile(double m) {
        return (m * 0.00062137);
    }
}
